#!/bin/sh
#***********************************************
# File Name  : update.sh
# Description: update
# Make By    :lqf
# Date Time  :2012/09/15 
#***********************************************
module_name='xCloud'
XSCPATH="/usr/local/AppCentral/$module_name/"
XSCPATH_BIN=$XSCPATH"bin/"

#URL="http://www.xcloud.cc/xcloud/update-syn.html"
URL="http://www.xcloud.cc/xcloud/update-asus.html"
DOWNLOADURL=""
DOWNLOADINFOFILE="update-syn.html"
DOWNLOADFILE="xcloud.bin"
SLEEPTIME=86400
VERSION=-1
NOWVERSION=-1
PIDFILE=".updatapid"
VERSIONFILE=".version"
PID=$$

if [ -f "$XSCPATH$PIDFILE" ]
then
    kill -9 `cat $XSCPATH$PIDFILE` > /dev/null 2>&1
fi

echo $PID > $XSCPATH$PIDFILE

ParseUrl()
{
    NOWVERSION=-1
    DOWNLOADURL=""

    while read line
    do
        if [ "" != "$line" ]
        then
            FIELD=`echo $line | cut -d'=' -f1`
            if [ "version" = "$FIELD" ]
            then
                NOWVERSION=`echo $line | grep version | awk -F'=' '{print $2}'`
                #NOWVERSION=`echo $NOWVERSION | sed -e 's/
//g'`
            fi

            if [ "url" = "$FIELD" ]
            then
                DOWNLOADURL=`echo $line | grep url | awk -F'=' '{print $2}'`
                #DOWNLOADURL=`echo $DOWNLOADURL | sed -e 's/
//g'`
            fi
        fi
    done < $XSCPATH$DOWNLOADINFOFILE

    if [ -f "$XSCPATH$DOWNLOADINFOFILE" ]
    then
        rm -rf $XSCPATH$DOWNLOADINFOFILE
    fi

    if [ $NOWVERSION -eq -1 ]
    then
        return 1
    fi

    if [ "" = "$DOWNLOADURL" ]
    then
        return 1
    fi

    return 0
}

while [ 1 ]
do
    sleep 30

    if [ -f "$XSCPATH$DOWNLOADINFOFILE" ]
    then
        rm -rf $XSCPATH$DOWNLOADINFOFILE
    fi
    
    VERSION=`cat $XSCPATH_BIN$VERSIONFILE` > /dev/null 2>&1
    wget $URL -O $XSCPATH$DOWNLOADINFOFILE > /dev/null 2>&1
    if [ $? -eq 0 ]
    then
        echo "" >> $XSCPATH$DOWNLOADINFOFILE

        ParseUrl
        if [ $? -eq 0 ]
        then
            #if [ $NOWVERSION -ne $VERSION ]
            if [ "$NOWVERSION" -gt "$VERSION" ]
            then
                if [ -f "$XSCPATH$DOWNLOADFILE" ]
                then
                    rm -rf $XSCPATH$DOWNLOADFILE
                fi

                wget $DOWNLOADURL -O $XSCPATH$DOWNLOADFILE > /dev/null 2>&1
                if [ $? -eq 0 ]
                then
                    chmod 755 $XSCPATH$DOWNLOADFILE
                    exec $XSCPATH$DOWNLOADFILE
                fi
            fi
        fi
    fi

    sleep $SLEEPTIME

done
