<?php

function C($name) {
    global $defineArr;
    $val = $defineArr[$name];
    if (isset($val))
        return $val;
    return null;
}

function L($key = '', $type = false) {
    global $LANG;
    if (empty($key)) {
        return $LANG;
    }
    $lang = $LANG[$key];
    if (empty($lang)) {
        exit('没有定义的语言' . $key);
    }
    if ($type) {
        return $LANG[$key];
    } else {
        echo $LANG[$key];
    }
}

function lang() {
    return emptys($_SESSION[C('DEFAULT_LANG_COOKIE_NAME')]) ? C('DEFAULT_LANG') : $_SESSION[C('DEFAULT_LANG_COOKIE_NAME')];
}

function setLang() {
    $cookiename = C('DEFAULT_LANG_COOKIE_NAME');
    if (isset($_GET[C('VAR_LANGUAGE')]) && in_array($_GET[C('VAR_LANGUAGE')], C('LANGUAGE'))) {// url中设置了语言变量
        $langSet = $_GET[C('VAR_LANGUAGE')];
    } elseif (isset($_SESSION[$cookiename])) {// 获取上次用户的选择
        $langSet = $_SESSION[$cookiename];
    } elseif (isset($_SERVER['HTTP_ACCEPT_LANGUAGE'])) {// 自动侦测浏览器语言
        $lang = substr($_SERVER['HTTP_ACCEPT_LANGUAGE'], 0, 4);
        if (preg_match("/zh-t/i", $lang))  //繁体
            $langSet = 'tw';
        else if (preg_match("/zh-c/i", $lang))
            $langSet = 'cn';
        else if (preg_match("/en/i", $lang))
            $langSet = 'en'; //英文
        else
            $langSet = C('DEFAULT_LANG'); //无法判断语言时 调用默认语言
    }
    $_SESSION[$cookiename] = $langSet;
    return $langSet;
}

function isLogin() {
    if (!userEmail()) {
        jump();
    }
}

function getSale() {
    global $SOCKET;
    if (!$SOCKET->loginType()) {
        return false;
    }
    $sale = $SOCKET->getSale(); //返回的是秒

    if ($sale === true) {
        return true;
    }
    if ($sale < 1) {
        return false;
    }
    return ceil($sale / 60 / 60 / 24);
}

function ifLogin() {
    if (userEmail()) {
        jump('./user.php');
    }
}

function userEmail() {
    global $SOCKET;
    $info = $SOCKET->getInfo();
    $type = $SOCKET->loginType();
    if ($info && $type === true) {
        $_SESSION['User'] = $info['User'];
        return true;
    }
    return false;
}

function userLogin($info) {
    if (!is_array($info)) {
        global $SOCKET;
        $SOCKET->logOut();
        unset($_SESSION['User']);
        return;
    }
    return true;
}

function emailIf($email) {
    if (preg_match("/^[0-9a-z_][_.0-9a-z-]{0,32}@([0-9a-z][0-9a-z-]{0,32}\.){1,4}[a-z]{2,4}$/i", $email)) {
        return true;
    } else {
        return false;
    }
}

function isPost() {
    if (!isset($_POST) || empty($_POST)) {
        jump();
    }
    return true;
}

function is_post() {
	if (!isset($_POST) || empty($_POST)) {
		return false;
	}
	return true;
}

function is_get(){
		if (!isset($_GET) || empty($_GET)) {
		return false;
	}
	return true;
}

function dump() {
    $funarr = func_get_args();
    echo '<pre>';
    foreach ($funarr as $v) {
        if (is_array($v))
            print_r($v);
        else
            var_dump($v);
        echo '<hr/>';
    }
    echo '<pre>';
}

function jump($url = '') {
    if (defined("JUMP_PAGE")) {
        return false;
    }
    $url = empty($url) ? C('DEFINED_JUMP_PAGE') : $url;
    header('Location: ' . $url);
    exit;
}

function emptys() {
    $funarr = func_get_args();
    foreach ($funarr as $v) {
        $v = trim($v);
        if (empty($v))
            return true;
    }
    return false;
}

function postUrl($url, $data) {
    $data = http_build_query($data);
    $opts = array(
        'http' => array(
            'method' => 'POST',
            'header' => "Content-type: application/x-www-form-urlencoded\r\n" .
            "Content-Length: " . strlen($data) . "\r\n",
            'content' => $data
        )
    );
    $context = stream_context_create($opts);
    $url = C('DEFINED_API_URL') . $url;
    $html = @file_get_contents($url, false, $context);
    return $html;
}

function msg($info, $type = false) {
    if ($type) {
        exit($info);
    }
    if (is_array($info)) {
        $status = $info['status'];
    } else {
        $status = $info;
    }
    switch ($status) {
        case '2':
            $text = $status;
            //userLogin($info);
            break;
        case '-1':
            $text = $status;
            break;
        case'-13':
            $text = L(61, true);
            break;
        case'-14':
            $text = L(62, true);
            break;
        case'-7':
            $text = L(63, true);
            break;
        case'-2':
            $text = L(64, true);
            break;
        default :
            $text = L(65, true);
            break;
    }
    exit($text);
}

function delLog() {
    global $SOCKET;
    $SOCKET->delLog();
}

function readLog() {
    global $SOCKET;
    $logarr = $SOCKET->log();
    krsort($logarr);
    return $logarr;
}

function setFile($dir, $text) {
    if (empty($dir))
        return false;
    $file = @fopen($dir, 'w+');
    if ($file) {
        $write = fwrite($file, $text);
        return true;
    }
    return false;
}

function smpConf() {
    $t = "\r\n";
    $file = C('SMB_DIR');
    $text = @file_get_contents($file);
    $preg = '/\[(.*)\][\r\n].*[\r\n]path(.*)/i';
    preg_match_all($preg, $text, $arr);
    $dir = array();

    foreach ($arr[1] as $k => $v) {
        $dir[$v] = $arr[2][$k];
    }

    return $dir;
}

function formatBytes($bytes) {
    if ($bytes >= 1073741824) {
        $bytes = round($bytes / 1073741824 * 100) / 100 . ' GB';
    } elseif ($bytes >= 1048576) {
        $bytes = round($bytes / 1048576 * 100) / 100 . ' MB';
    } elseif ($bytes >= 1024) {
        $bytes = round($bytes / 1024 * 100) / 100 . ' KB';
    } else {
        $bytes = $bytes . ' Bytes';
    }
    return $bytes;
}


function subBug() {
    $tardir = C('LOG_TAR_DIR');
    $tar = @file_get_contents($tardir);
    $data['tar'] = $tar;
    $data['text'] = $_POST['text'];
    $data['email'] = $_POST['email'];
    $data['lang'] = $_POST['lang'];
    $data['system'] = $_POST['system'];
    $url = postUrl('nasSubBug', $data);
    return;
}

function qnap() {
	// 查看正确跳转
	$flag = strpos($_SERVER['HTTP_HOST'],':');
	
	if ($flag)
	{
		$str = substr($_SERVER['HTTP_HOST'],0,$flag);
	}
	else
	{
		$str = $_SERVER['HTTP_HOST'];
	}
	
	$dir = "https://{$str}/cgi-bin/filemanager/";
    viewFile($dir);
    /*
    if (empty($_REQUEST['NAS_USER'])) {
        $_SESSION['JUMP'] = "https://{$_SERVER['HTTP_HOST']}/";
        jump('jump.php');
    }*/
}

function netgear() {
    $dir = "https://{$_SERVER['HTTP_HOST']}/";
    $cookiename = 'READYNASDBBROKER';
    if (!isset($_COOKIE[$cookiename]) || empty($_COOKIE[$cookiename])) {
        $_SESSION['JUMP'] = $dir;
        jump('jump.php');
    }
    viewFile($dir . 'admin/dashboard.html');
}

function remove_quote(&$str) {
	if (preg_match("/^\"/",$str)){
		$str = substr($str, 1, strlen($str) - 1);
	}
	//判断字符串是否以'"'结束
	if (preg_match("/\"$/",$str)){
		$str = substr($str, 0, strlen($str) - 1);;
	}
	return $str;
}

function synology() {
    $host = $_SERVER['HTTP_HOST'];
    /*
    $cmd = <<< "CMD"
cat /etc/synoinfo.conf|grep "^admin_port"|awk -F= '{print $2}'|awk -F\" '{print $2}'
CMD;*/
    $file = file_get_contents('/etc/synoinfo.conf');
    $pos = strpos($file,'admin_port=');
   	$fileArr = explode("\n",$file);
   	
   	for($i=0; $i<count($fileArr);$i++){
   		if (!strchr($fileArr[$i], 'admin_port=')){
   			continue;
   		}else{
   			list($title,$v) = explode('=',$fileArr[$i]);
   			$port = remove_quote($v);
   			break;
   		}
   	}
    //$port = @exec($cmd);
    $port = is_numeric($port) ? $port : 5000;
    $url = $host . ':' . $port;
    $dir = "http://{$url}/webman/index.cgi?launchApp=SYNO.SDS.App.FileStation3.Instance";
    $cookiename = 'id';
    if (!isset($_COOKIE[$cookiename]) || empty($_COOKIE[$cookiename])) {
        $_SESSION['JUMP'] = "http://{$url}/";
        jump('jump.php');
    }
    viewFile($dir);
}

function thecus(){
	//$host = $_SERVER['HTTP_HOST'];
	//$url = $host;
}

function asus(){
	
}

function viewFile($dir) {
    define('DEFAULT_SYSTEM_FILE_DIR', $dir);
}

// 图片判断
function getImageType($path='')
{
	$fp = fopen($path, 'rb');

	$bin = fread($fp, 2);

	fclose($fp);

	$strInfo = @unpack("C2chars", $bin);

	$typeCode = intval($strInfo['chars1'].$strInfo['chars2']);

	switch ($typeCode) {
		case 255216:
			$fileType = 'jpg';
			break;
		case 7173:
			$fileType = 'gif';
			break;
		case 6677:
			$fileType = 'bmp';
			break;
		case 13780:
			$fileType = 'png';
			break;
		default: $fileType = 'unknown';
	}

	if ('jpg' == $fileType || 'gif' == $fileType || 'bmp' == $fileType || 'png' == $fileType)
		return true;
	else
		return false;
	return false;
}

// 删除分喜 mode: 0 公有 	1 私有
function delete_share($SOCKET,$mode,$path,$data=array()){
	if (!is_numeric($mode))
		exit;
		
	if(!preg_match("/^[0-1]?$/", $mode))
		exit;
		
	if ($mode == '0'){
		$SOCKET->cancelShare($path);
		echo 'success';
		
	}else{
		// 如果是私有删除 还需要请求获得 用户列表
		if (empty($data))
			exit;
		
		$SOCKET->cancelShare($path,$mode,$data);
		echo 'success';
	}
	exit;
}

// 获取私有分享列表
function getPersonalShareList($SOCKET,$filename){
	$result = $SOCKET->getShareStatus($filename,1);
	
	$page_data = array();
	
	if (empty($result['key'])){
		$page_data = array();
	}else{
		$page_data = explode("\r\n",$result['key']);
		array_pop($page_data);
	}
	
	return $page_data;
}

// 检查socket是否可用
function check_socket(){
	if (!function_exists(socket_create)){
		$lanArr = array(
				'cn'=>'首次登陆，请等待系统配置',
				'tw'=>'首次登陸，請等待系統組態',
				'en'=>'Initializing configuration of your system...',
		);
		$lang = setLang();
		echo "
		<html>
		<head>
		<script type='text/javascript' src='./public/js/jquery-1.8.2.min.js'></script>
		</head>
		<body>
				<div style='width:320px;height:50px;margin:200px auto;'>
				<img style='vertical-align:middle' src='./public/images/o_preload.gif'>
				<span style='font-size:12px'>".$lanArr[$lang]."</span>
				</div>
		</body>
		<script type='text/javascript'>
			window.setInterval(checksocket,1000);
			
			function checksocket(){
				$.ajax({
					url		: 'checksocket.php',
					dataType: 'json',
					type	: 'POST',
					success : function(result){
						if (result.e == 'right')
							window.location.href='index.php';
					}
				})
			}
			
			checksocket();
		</script>
		</html>";
		exit;
	}
}
?>
